/*
 * Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     zhanglei <zhanglei@uniontech.com>
 *
 * Maintainer: zhanglei <zhanglei@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef AGNET_H
#define AGNET_H

#include "agentdbus.h"

#include <QObject>
#include <QDBusInterface>

class Agent : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", AGENT_INTERFACE_NAME)

public:
    explicit Agent(QObject *parent = Q_NULLPTR);
    ~Agent();

public slots:
    Q_SCRIPTABLE void updateDeviceTreeFile(const QByteArray &data);
    Q_SCRIPTABLE void updateCustomFile(const QByteArray &data);
    Q_SCRIPTABLE void downloadQRCode(QString savePath, QString saveName, const QByteArray &data);
};

#endif //AGENT_H
