/*
 * Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     zhanglei <zhanglei@uniontech.com>
 *
 * Maintainer: zhanglei <zhanglei@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "agent.h"
#include "agentdbus.h"

#include <DLog>

#include <QCoreApplication>
#include <QtDBus/QtDBus>
#include <QDebug>

int main(int argc, char *argv[])
{
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF-8"));

    QCoreApplication app(argc, argv);
    app.setOrganizationName("uos-agent");

    Dtk::Core::DLogManager::registerConsoleAppender();
    Dtk::Core::DLogManager::registerFileAppender();

    Agent agent;

    if (!QDBusConnection::systemBus().isConnected()) {
        qDebug() << "QDBusConnection::systemBus().isConnected() failed";
        exit(0x0001);
    }

    if (!QDBusConnection::systemBus().registerService(SERVICE_NAME)) {
        qDebug() << "registerService Error" << QDBusConnection::systemBus().lastError();
        exit(0x0002);
    }

    QDBusConnection::RegisterOptions options = QDBusConnection::ExportAllSlots;

    if (!QDBusConnection::systemBus().registerObject(AGENT_SERVICE_PATH, AGENT_INTERFACE_NAME, &agent, options)) {
        qDebug() << "registerObject Daemon Error" << QDBusConnection::systemBus().lastError();
        exit(0x0003);
    }

    app.exec();

    return 0;
}
