/*
 * Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     liutianming <liutianming@uniontech.com>
 *
 * Maintainer: liutianming <liutianming@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef DEEPINACCOUNT_H
#define DEEPINACCOUNT_H

#include <QObject>
#include <QDBusConnection>
#include <QDBusInterface>
#include <QDebug>

const QString DEEPINIDSERVICE = "com.deepin.deepinid";
const QString DEEPINIDPATH = "/com/deepin/deepinid";
const QString DEEPINIDINTERFACE = "com.deepin.deepinid";
const QString DEEPINIDPROPERTIES = "org.freedesktop.DBus.Properties";

class DeepinAccount : public QObject
{
    Q_OBJECT
public:
    explicit DeepinAccount(QObject *parent = nullptr);
    ~DeepinAccount();
    bool loginStatus;

public slots:
    void signUp();
    void exitLogin();
    void initStatus();

signals:
    void loggedIn(QString userName, QString avatarPath);
    void loggedOut();
    void createUser(QByteArray data);

private slots:
    void init();
    void userInfoChanged(QString str, QVariantMap map, QStringList list);
    QByteArray spliceUserInfo();

private:
    QDBusInterface *m_netInterface;
    QDBusInterface *m_proprtyInterface;
    QString m_avatarPath;
    QString m_userName;
    QString m_nickName;
    int m_userId;

};

#endif // DEEPINACCOUNT_H
