/*
 * Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     liutianming <liutianming@uniontech.com>
 *
 * Maintainer: liutianming <liutianming@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "licensestatus.h"

#include "common/unit.h"

bool LicenseStatus::authorizeStatus = false;

LicenseStatus::LicenseStatus(QObject *parent)
    : QObject (parent)
{
    init();
}

LicenseStatus::~LicenseStatus()
{

}

//授权状态改变
void LicenseStatus::licenseStatusChanged()
{
    uint statusCode = m_interface->property("AuthorizationState").toUInt();

    if (statusCode == Authorized || statusCode == TrialAuthorized) {
        authorizeStatus = true;
    } else {
        authorizeStatus = false;
    }
}

void LicenseStatus::wakeLicenseInterface()
{
    QDBusInterface interface("com.deepin.license.activator", "/com/deepin/license/activator", "com.deepin.license.activator", QDBusConnection::sessionBus());
    interface.call(QDBus::AutoDetect, "Show");
}

void LicenseStatus::init()
{
    m_interface = new QDBusInterface(INTERGACEADRESS, INTERGACEPATH, INTERGACEOBJECT, QDBusConnection::systemBus());
    licenseStatusChanged();

    connect(m_interface, SIGNAL(LicenseStateChange()), this, SLOT(licenseStatusChanged()));
}
