/*
 * Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     zhangminjiezhangminjie <zhangminjie@uniontech.com>
 *
 * Maintainer: zhangminjie <zhangminjie@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef CONTACTUS_H
#define CONTACTUS_H

#include <DWidget>
#include <DLabel>
#include <DFrame>
#include <DComboBox>
#include <DIconButton>

#include <QMap>
#include <QUrl>
#include <QIcon>
#include <QString>
#include <QBoxLayout>
#include <QHBoxLayout>
#include <QStringList>
#include <QVariantMap>

DWIDGET_USE_NAMESPACE

class ContactUs : public DWidget
{
    Q_OBJECT
public:
    explicit ContactUs(QWidget *parent = Q_NULLPTR);
    ~ContactUs();
    DFrame *createArchFrame();
    DFrame *createCardFrame();

public slots:
    //服务端返回客户信息
    void updateCustomerInfo(const QByteArray &data);
    void updateComboBox();

private slots:
    void onSystemComboBoxIndexChanged(const QString &value);
    void onBlockComboBoxIndexChanged(const QString &value);
    void onItemComboBoxIndexChanged(const QString &value);

signals:
    void searchCustomInfo(const QByteArray &data);

private:
    void searchCustomerInfo(const QString &system, const QString &block, const QString &item);
    void initComboBox();
    //读取本地文件更新客服信息
    void updateOfflineCustomInfo();

private:
    DComboBox *m_consultationTypeOne;
    DComboBox *m_consultationTypeTwo;
    DComboBox *m_consultationTypeThree;
    DLabel *m_companyLabel;
    DLabel *m_telephoneTextLabel;
    DLabel *m_emailAddressLabel;
    DLabel *m_qrcodeLabel;
    QString m_curSerchKey;
    QUrl m_netAdress;
};

#endif // CONTACTUS_H
