﻿/*
 * Copyright (C) 2019 ~ 2020 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     liutianming <liutianming@uniontech.com>
 *
 * Maintainer: liutianming <liutianming@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef NONETWORKWIDGET_H
#define NONETWORKWIDGET_H

#include <DWidget>
#include <DLabel>
#include <DSuggestButton>

#include <QTimer>

DWIDGET_USE_NAMESPACE

class NoNetworkWidget : public DWidget
{
    Q_OBJECT
public:
    explicit NoNetworkWidget(QWidget *parent = Q_NULLPTR);
    ~NoNetworkWidget() override;

    void resetValue();

public slots:
    void setCountdown();

protected:
    void showEvent(QShowEvent *event) override;
    void hideEvent(QHideEvent *event) override;

private:
    void initUI();
    void setLabelText();

signals:
    void changePage();

private:
    DLabel *m_contentLabel;
    DLabel *m_countDownLabel;
    QString m_content;
    QString m_countDown;
    QTimer *m_timer;
    int m_timeNum;
};

#endif // NONETWORKWIDGET_H
